com.google.appengine.api.search.checkers

## Class Preconditions

- java.lang.Object
- - com.google.appengine.api.search.checkers.Preconditions

-     public final class Preconditions
      extends java.lang.Object

  Simple static methods to be called at the start of your own methods to verify correct arguments and state. This allows constructs such as

       if (count <= 0) {
         throw new IllegalArgumentException("must be positive: " + count);
       }

  to be replaced with the more compact

            checkArgument(count > 0, "must be positive: %s", count);

  Note that the sense of the expression is inverted; with `Preconditions` you declare what you expect to be true, just as you do with an `assert` or a JUnit `assertTrue` call.

  Note:This class is a copy of a very old version of Guava's Preconditions. Please use the current Guava version instead.

  See Also:
    "https://google.github.io/guava/releases/21.0/api/docs/com/google/common/base/Preconditions.html"

- - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static void` | `checkArgument(boolean expression, java.lang.Object errorMessage)` Ensures the truth of an expression involving one or more parameters to the calling method.
    `static void` | `checkArgument(boolean expression, java.lang.String errorMessageTemplate, java.lang.Object... errorMessageArgs)` Ensures the truth of an expression involving one or more parameters to the calling method.
    `static <T> T` | `checkNotNull(T reference, java.lang.Object errorMessage)` Ensures that an object reference passed as a parameter to the calling method is not null.
    `static void` | `checkState(boolean expression, java.lang.String errorMessage)` Ensures the truth of an expression involving the state of the calling instance.
    `static void` | `checkState(boolean expression, java.lang.String errorMessageTemplate, java.lang.Object... errorMessageArgs)` Ensures the truth of an expression involving the state of the calling instance.

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### checkArgument

          public static void checkArgument(boolean expression,
                                           java.lang.Object errorMessage)

      Ensures the truth of an expression involving one or more parameters to the calling method.
      Parameters:
        `expression` - a boolean expression
        `errorMessage` - the exception message to use if the check fails; will be converted to a string using `String.valueOf(Object)` if not null (a null will not be converted).
      Throws:
        `java.lang.IllegalArgumentException` - if `expression` is false

    - #### checkArgument

          public static void checkArgument(boolean expression,
                                           java.lang.String errorMessageTemplate,
                                           java.lang.Object... errorMessageArgs)

      Ensures the truth of an expression involving one or more parameters to the calling method.
      Parameters:
        `expression` - a boolean expression
        `errorMessageTemplate` - a template for the exception message should the check fail. The message is formed using `String.format(String, Object...)`. if not null (a null will not be converted).
        `errorMessageArgs` - the arguments to be substituted into the message template.
      Throws:
        `java.lang.IllegalArgumentException` - if `expression` is false

    - #### checkNotNull

          public static <T> T checkNotNull(T reference,
                                           java.lang.Object errorMessage)

      Ensures that an object reference passed as a parameter to the calling method is not null.
      Parameters:
        `reference` - an object reference
        `errorMessage` - the exception message to use if the check fails; will be converted to a string using `String.valueOf(Object)`
      Returns:
        the non-null reference that was validated
      Throws:
        `java.lang.NullPointerException` - if `reference` is null

    - #### checkState

          public static void checkState(boolean expression,
                                        java.lang.String errorMessageTemplate,
                                        java.lang.Object... errorMessageArgs)

      Ensures the truth of an expression involving the state of the calling instance.
      Parameters:
        `expression` - a boolean expression
        `errorMessageTemplate` - a template for the exception message should the check fail. The message is formed using `String.format(String, Object...)`. if not null (a null will not be converted).
        `errorMessageArgs` - the arguments to be substituted into the message template.
      Throws:
        `java.lang.IllegalStateException` - if `expression` is false

    - #### checkState

          public static void checkState(boolean expression,
                                        java.lang.String errorMessage)

      Ensures the truth of an expression involving the state of the calling instance.
      Parameters:
        `expression` - a boolean expression
        `errorMessage` - the exception message to use if the check fails; will be converted to a string using `String.valueOf(Object)` if not null (a null will not be converted).
      Throws:
        `java.lang.IllegalStateException` - if `expression` is false